<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Order ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Order extends AbstractStructArrayBase
{
    /**
     * The AdultAdditional
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Order[]
     */
    public $AdultAdditional;
    /**
     * Constructor method for ArrayOfJPSOAP_Order
     * @uses ArrayOfJPSOAP_Order::setAdultAdditional()
     * @param \StructType\JPSOAP_Order[] $adultAdditional
     */
    public function __construct(array $adultAdditional = array())
    {
        $this
            ->setAdultAdditional($adultAdditional);
    }
    /**
     * Get AdultAdditional value
     * @return \StructType\JPSOAP_Order[]|null
     */
    public function getAdultAdditional()
    {
        return $this->AdultAdditional;
    }
    /**
     * This method is responsible for validating the values passed to the setAdultAdditional method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdultAdditional method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdultAdditionalForArrayConstraintsFromSetAdultAdditional(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_OrderAdultAdditionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderAdultAdditionalItem instanceof \StructType\JPSOAP_Order) {
                $invalidValues[] = is_object($arrayOfJPSOAP_OrderAdultAdditionalItem) ? get_class($arrayOfJPSOAP_OrderAdultAdditionalItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_OrderAdultAdditionalItem), var_export($arrayOfJPSOAP_OrderAdultAdditionalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdultAdditional property can only contain items of type \StructType\JPSOAP_Order, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Order[] $adultAdditional
     * @return \ArrayType\ArrayOfJPSOAP_Order
     */
    public function setAdultAdditional(array $adultAdditional = array())
    {
        // validation for constraint: array
        if ('' !== ($adultAdditionalArrayErrorMessage = self::validateAdultAdditionalForArrayConstraintsFromSetAdultAdditional($adultAdditional))) {
            throw new \InvalidArgumentException($adultAdditionalArrayErrorMessage, __LINE__);
        }
        $this->AdultAdditional = $adultAdditional;
        return $this;
    }
    /**
     * Add item to AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Order $item
     * @return \ArrayType\ArrayOfJPSOAP_Order
     */
    public function addToAdultAdditional(\StructType\JPSOAP_Order $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Order) {
            throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of type \StructType\JPSOAP_Order, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdultAdditional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Order|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Order|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Order|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Order|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Order|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdultAdditional
     */
    public function getAttributeName()
    {
        return 'AdultAdditional';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_Order
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
